// Library     : DPMI
// Description : DOS Protected Mode Interface function library
// Module      : DPMI04.C
// Version     : 1.00 - 01/09/1994
// Written by  : David A. Mair
// -----------------------------------------------------------------------------
// Change summary --------------------------------------------------------------
// -----------------------------------------------------------------------------
//    Date   | Version | Comment and author
// -----------------------------------------------------------------------------
//           |         |
//           |         |
// -----------------------------------------------------------------------------


// Inline assembler is included in this module
#pragma inline

#include "dpmi.h"


DPMI_VERSION_INFO GetDPMIVersion(void)
{
	DPMI_VERSION_INFO RetVal;

	asm {
		mov		ax, 0x0400
		int		0x31

		mov		byte ptr [RetVal], ah
		mov		byte ptr [RetVal + 1], al
		mov		word ptr [RetVal + 2], bx
		mov		byte ptr [RetVal + 4], cl
		mov		byte ptr [RetVal + 5], dh
		mov		byte ptr [RetVal + 6], dl
	}

	return RetVal;
}


DPMI_CAPABILITIES GetDPMICapabilities(void)
{
	DPMI_CAPABILITIES RetVal;

	asm {
		mov		ax, 0x0401
		push	ds
		push	es
		int		0x31

		mov		word ptr [RetVal], ax

#ifdef __DPMI32__		
		mov		ax, word ptr es:[edi]
		mov		word ptr [RetVal + 2], ax
		
		mov		ax, es
		mov		ebx, edi
		
		mov		cx, ss
		mov		es, cx
		lea		edi, RetVal
		add		edi, 0x00000004

		mov		ds, ax
		mov		esi, ebx
		add		ebx, 0x00000002

		mov		ecx, 0x0000007E
#else
		mov		ax, word ptr es:[di]
		mov		word ptr [RetVal + 2], ax

		mov		ax, es
		mov		bx, di

		mov		cx, ss
		mov		es, cx
		lea		di, RetVal
		add		di, 0x0004
		mov		ds, ax
		mov		si, bx
		add		bx, 0x0002

		mov		cx, 0x007E
#endif
		rep		movsb

		pop		es
		pop		ds
	}

	return RetVal;
}
